/// @addtogroup dynsys
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file dynsyslib.h
///
/// @author Daniel Wilczak
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file constitutes a part of the CAPD library, 
// distributed under the terms of the GNU General Public License.
// Consult  http://capd.wsb-nlu.edu.pl/ for details. 

/* Author: Daniel Wilczak 2005 */

#ifndef _CAPD_DYNSYS_DYNSYSLIB_H_ 
#define _CAPD_DYNSYS_DYNSYSLIB_H_ 

#include "capd/factrial.h"
#include "map/Map.h"
#include "map/C2Map.h"
#include "dynsys/TaylorException.h"
#include "dynsys/C2Taylor.h"
#include "dynsys/Linear2d.h"
#include "dynsys/Linear3d.h"
#include "dynsys/VLin3D.h"
#include "dynsys/OdeNumTaylor.h"

typedef capd::dynsys::DynSys<IMatrix> DynSys;
typedef capd::dynsys::Ode<IMatrix> Ode;
typedef capd::dynsys::OdeNum<IMatrix> OdeNum;
typedef capd::dynsys::OdeNumTaylor<IMatrix> OdeNumTaylor;
typedef capd::dynsys::VLin3D<IMatrix> VLin3D;
typedef capd::dynsys::Linear2d<IMatrix> linear2d;
typedef capd::dynsys::Linear3d<IMatrix> linear3d;
typedef capd::dynsys::Taylor<capd::map::Map<IMatrix> > Taylor;
typedef capd::dynsys::C2Taylor<capd::map::C2Map<IMatrix> > C2Taylor;
typedef capd::dynsys::TaylorException<IVector> TaylorException;

// classes for nonrigorous computations
typedef capd::dynsys::BasicTaylor<capd::map::Map<DMatrix> > BasicTaylor;
typedef capd::dynsys::BasicC2Taylor<capd::map::C2Map<DMatrix> > BasicC2Taylor;

#endif // _CAPD_DYNSYS_DYNSYSLIB_H_ 

/// @}
