/// @addtogroup poincare
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file PoincareMap.cpp
///
/// @author Daniel Wilczak
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file constitutes a part of the CAPD library, 
// distributed under the terms of the GNU General Public License.
// Consult  http://capd.wsb-nlu.edu.pl/ for details. 


#include "interval/doubleInterval.h"
#include "vectalg/dimension.h"
#include "vectalg/Matrix.hpp"
#include "map/CnMap.hpp"
#include "dynsys/CnTaylor.hpp"
#include "poincare/PoincareMap.hpp"

typedef capd::map::CnMap< capd::vectalg::Matrix<double,DIM,DIM>, 3> CnMap;
typedef capd::map::CnMap< capd::vectalg::Matrix<interval,DIM,DIM>, 3> ICnMap;
typedef capd::dynsys::BasicCnTaylor<CnMap> BasicCnTaylor;
typedef capd::dynsys::CnTaylor<ICnMap> CnTaylor;

template class capd::poincare::BasicPoincareMap<BasicCnTaylor>;
template class capd::poincare::PoincareMap<CnTaylor>;

/// @}
