/// @addtogroup poincare
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file TimeMapTSC.cpp
///
/// @author Daniel Wilczak
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file constitutes a part of the CAPD library, 
// distributed under the terms of the GNU General Public License.
// Consult  http://capd.wsb-nlu.edu.pl/ for details. 


#include "interval/doubleInterval.h"
#include "vectalg/dimension.h"
#include "vectalg/Matrix.hpp"
#include "map/Map.hpp"
#include "dynsys/Taylor.hpp"
#include "poincare/TimeMapTSC.hpp"

typedef capd::map::Map< capd::vectalg::Matrix<interval,DIM,DIM> > Map;
typedef capd::dynsys::Taylor<Map> Taylor;

template class capd::poincare::TimeMapTSC<Taylor>;

/// @}
